###############################################################################
# StopForumSpam.pl                                                            #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.5 Anniversary Edition                                #
# Packaged:       July 04, 2010                                               #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2010 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$stopforumspamplver = 'YaBB 2.5 AE $Revision: 0.6 $';
if ($action eq 'detailedversion') { return 1; }

sub CheckForumSpam {
 
    eval { require LWP::UserAgent };
    my $moduleUA = $@;
    eval { require XML::Simple };
    my $moduleSimple = $@;
    eval { require XML::SAX };
    my $moduleSAX = $@;
        
    unless ($moduleUA || $moduleSimple || $moduleSAX) {
        
        $ua = new LWP::UserAgent;
        $ua->timeout($sfs_connection_timeout);

        $sfs_url = "http://www.stopforumspam.com/api?username=" . $sfs_username . "&ip=" . $user_ip . "&email=" . $sfs_email;
        $get_reg_spam = $ua->get($sfs_url);
    
        if ($get_reg_spam->is_success) {
            $xml = new XML::Simple;
            $spam_user_check = $xml->XMLin($get_reg_spam->content);
            if (($check_sfs_username && $spam_user_check->{appears}->[0] eq "yes") || ($check_sfs_ip && $spam_user_check->{appears}->[1] eq "yes") || ($check_sfs_email && $spam_user_check->{appears}->[2] eq "yes")) {
                 $sfs_ban_ip = 0;
                 $sfs_ban_email = 0;
                 if (($sfs_ip_ban && $check_sfs_ip && $spam_user_check->{appears}->[1] eq "yes") || ($sfs_ip_ban && $check_sfs_ip && $sfs_ban_all && $sfs_email_ban && $check_sfs_email && $spam_user_check->{appears}->[2] eq "yes")) {
                      my @ipbanlist;
                      foreach (split(/,/, $ip_banlist)) {
                          unless ($_ eq $user_ip) { push(@ipbanlist, $_); }
                      }
                      push(@ipbanlist, $user_ip);
                      $ip_banlist = join(',', @ipbanlist);
                      $sfs_ban_ip = 1;
                 }              
                 if (($sfs_email_ban && check_sfs_email && $spam_user_check->{appears}->[2] eq "yes") || ($sfs_email_ban && $check_sfs_email && $sfs_ban_all && $sfs_ip_ban && $check_sfs_ip && $spam_user_check->{appears}->[1] eq "yes")) {
                      my @emailbanlist;
                      foreach (split(/,/, $email_banlist)) {
                          unless ($_ eq $sfs_email) { push(@emailbanlist, $_); }
                      }
                      push(@emailbanlist, $sfs_email);
                      $email_banlist = join(',', @emailbanlist);
                      $sfs_ban_email = 1;
                 }
                 if ($sfs_ban_ip || $sfs_ban_email) {
                     require "$admindir/NewSettings.pl";
                     &SaveSettingsTo('Settings.pl');
                 }
                 if ($use_guardian && $use_htaccess && $sfs_ip_block && $check_sfs_ip && $spam_user_check->{appears}->[1] eq "yes") {
                     my @ipblock;
                     require "$admindir/GuardianAdmin.pl";
                     @sfs_access_denied = &update_htaccess("load");
                     foreach (@sfs_access_denied) {
                         unless ($_ eq $user_ip) { push(@ipblock, $_); }
	                 }
	                 push(@ipblock, $user_ip);
	                 &update_htaccess("save", @ipblock);
	             }
                 if ($sfs_custom_url) { 
                     &ForumSpamStats;
                     print "Location: $sfs_custom_url\n\r\n\r";
                     if ($action eq "register2") { 
                         if ($sfs_log) {
                             $sfs_status = "blocked";
                             &ForumSpamLog;
                         }
                         &fatal_error("reg_spam"); 
                     } else {
                         &fatal_error("post_spam"); 
                     }
                 } else {
                     &ForumSpamStats;
                     if ($action eq "register2") { 
                         if ($sfs_log) {
                             $sfs_status = "blocked";
                             &ForumSpamLog;
                         }
                         &fatal_error("reg_spam"); 
                     } else {
                         &fatal_error("post_spam"); 
                    }
                 }
            }
        } elsif ($check_sfs_connection) { 
            if ($action eq "register2") {
                if ($sfs_log) {
                    $sfs_status = $get_reg_spam->code;
                    &ForumSpamLog;
                }
                &fatal_error("reg_spam_error");
            } else {
                &fatal_error("post_spam_error");
            }
        } elsif ($sfs_log && $action eq "register2") {
            $sfs_status = $get_reg_spam->code;
            &ForumSpamLog;
            return;
        }
        
        if ($sfs_log && $action eq "register2") {
            $sfs_status = "ok";
            &ForumSpamLog;
        }   
    
    }

}

sub SubmitForumSpam {

    unless ($iamadmin && $sfs_submit && $sfs_api_key && ($INFO{'sfs_username'} || $FORM{'sfs_username'})) { &fatal_error("not_allowed"); }
    
    &LoadLanguage('StopForumSpam');

    $sfs_username = $INFO{'sfs_username'} || $FORM{'sfs_username'};
    $sfs_ip = $INFO{'sfs_ip'} || $FORM{'sfs_ip'};
    $sfs_email = $INFO{'sfs_email'} || $FORM{'sfs_email'};
    
    $username = $sfs_username;
    if ($do_scramble_id) { $username = &cloak($sfs_username); }
    
    if ($sfs_username =~ m/s$/) { $apos = "'"; }
    else { $apos = "'s"; }
    
    eval { require LWP::UserAgent };
    my $moduleUA = $@;

    unless ($moduleUA) {

        $ua = new LWP::UserAgent;
        $ua->timeout($sfs_connection_timeout);
        
        $sfs_request = $ua->post('http://www.stopforumspam.com/post.php', 
                                 [ username => $sfs_username,
                                   ip_addr => $sfs_ip,
                                   email => $sfs_email, 
                                   api_key => $sfs_api_key, 
                                 ]);
        $sfs_request->content_type('application/x-www-form-urlencoded');
        
        if ($sfs_request->code == 200) {
            $sfs_response = "<p>$sfs_txt{'success'}</p>";
            $sfs_response .= $sfs_request->content;
            &ForumSpamStats;
        } elsif ($sfs_request->code == 403) {
            $sfs_response = "<p>$sfs_txt{'submit_error'}</p>";
            $sfs_response .= $sfs_request->content;
        } else {
            $sfs_response = "<p>$sfs_txt{'connection_error'}</p>";
        }
        
        if ($INFO{'sfs_username'}) {
            $sfs_return = qq~<a href="$scripturl?action=viewprofile;username=$username">$sfs_txt{'profile_return1'} $sfs_username$apos $sfs_txt{'profile_return2'}</a>~;
        } else {
            $sfs_return = qq~<a href="$adminurl?action=view_reglog">$sfs_txt{'reglog_return'}</a>~;
        }
        
    } else { 
        $sfs_response = "<p>$sfs_txt{'module_error'}</p>";
    }

    $yymain = qq~
<table width="100%" align="center" border="0" cellpadding="4" cellspacing="1" class="bordercolor">
<tr>
    <th class="catbg" style="text-align: left;"><img src="$imagesdir/sfs.png" border="0" alt="" style="vertical-align: middle;" /> $sfs_txt{'stopforumspam'}</th>
</tr>
<tr>
    <td class="windowbg" style="text-align: center;">
        <p style="font-weight: bold;">$sfs_txt{'response'}</p> 
        $sfs_response
        <p>$sfs_return</p>
    </td>
</tr>
</table>~;

    $yytitle = qq~$sfs_txt{'stopforumspam'}~;
    $yynavigation = qq~&rsaquo; $sfs_txt{'stopforumspam'}~;
    &template;

}

sub ForumSpamLog {
        
    fopen(ForumSpamLog, ">>$vardir/stopforumspam.log");
    print ForumSpamLog "$date|$sfs_status|$sfs_username|$sfs_email|$user_ip\n";
    fclose(ForumSpamLog);
    
}

sub ForumSpamStats {

    if (-e "$vardir/sfs_stats.txt") { require "$vardir/sfs_stats.txt"; }
    
    $sfs_blocked ||= 0;
    $sfs_submitted ||= 0;
    
    if ($INFO{'sfs_username'} || $FORM{'sfs_username'}) { $sfs_submitted++; }
    else { $sfs_blocked++; }

    fopen(SFSTATS, ">$vardir/sfs_stats.txt");
	print SFSTATS qq~\$sfs_blocked = "$sfs_blocked";\n~;
	print SFSTATS qq~\$sfs_submitted = "$sfs_submitted";\n~;
	print SFSTATS qq~1;~;
	fclose(SFSTATS);

}
       
1;